Index: trunk/sources/HeuristicLab.Selection/3.3/BestSelector.cs
===================================================================
--- trunk/sources/HeuristicLab.Selection/3.3/BestSelector.cs	(revision 3137)
+++ trunk/sources/HeuristicLab.Selection/3.3/BestSelector.cs	(revision 3138)
@@ -20,10 +20,10 @@
 #endregion
 
-using System;
+using System.Collections.Generic;
 using System.Linq;
-using System.Collections.Generic;
 using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Data;
 
 namespace HeuristicLab.Selection {
@@ -34,5 +34,5 @@
   [StorableClass]
   [Creatable("Test")]
-  public sealed class BestSelector : SingleObjectiveSelector {
+  public sealed class BestSelector : SingleObjectiveSelector, ISingleObjectiveSelector {
     public BestSelector() : base() { }
 
Index: trunk/sources/HeuristicLab.Selection/3.3/LeftReducer.cs
===================================================================
--- trunk/sources/HeuristicLab.Selection/3.3/LeftReducer.cs	(revision 3137)
+++ trunk/sources/HeuristicLab.Selection/3.3/LeftReducer.cs	(revision 3138)
@@ -22,4 +22,5 @@
 using System.Collections.Generic;
 using HeuristicLab.Core;
+using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -31,5 +32,5 @@
   [StorableClass]
   [Creatable("Test")]
-  public sealed class LeftReducer : Reducer {
+  public sealed class LeftReducer : Reducer, IReducer {
     public LeftReducer() : base() { }
 
Index: trunk/sources/HeuristicLab.Selection/3.3/LinearRankSelector.cs
===================================================================
--- trunk/sources/HeuristicLab.Selection/3.3/LinearRankSelector.cs	(revision 3137)
+++ trunk/sources/HeuristicLab.Selection/3.3/LinearRankSelector.cs	(revision 3138)
@@ -24,4 +24,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -33,5 +34,5 @@
   [StorableClass]
   [Creatable("Test")]
-  public sealed class LinearRankSelector : StochasticSingleObjectiveSelector {
+  public sealed class LinearRankSelector : StochasticSingleObjectiveSelector, ISingleObjectiveSelector {
     public LinearRankSelector() : base() { }
 
Index: trunk/sources/HeuristicLab.Selection/3.3/MergingReducer.cs
===================================================================
--- trunk/sources/HeuristicLab.Selection/3.3/MergingReducer.cs	(revision 3137)
+++ trunk/sources/HeuristicLab.Selection/3.3/MergingReducer.cs	(revision 3138)
@@ -22,4 +22,5 @@
 using System.Collections.Generic;
 using HeuristicLab.Core;
+using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -31,5 +32,5 @@
   [StorableClass]
   [Creatable("Test")]
-  public sealed class MergingReducer : Reducer {
+  public sealed class MergingReducer : Reducer, IReducer {
     public MergingReducer() : base() { }
 
Index: trunk/sources/HeuristicLab.Selection/3.3/ProportionalSelector.cs
===================================================================
--- trunk/sources/HeuristicLab.Selection/3.3/ProportionalSelector.cs	(revision 3137)
+++ trunk/sources/HeuristicLab.Selection/3.3/ProportionalSelector.cs	(revision 3138)
@@ -25,4 +25,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -35,5 +36,5 @@
   [StorableClass]
   [Creatable("Test")]
-  public sealed class ProportionalSelector : StochasticSingleObjectiveSelector {
+  public sealed class ProportionalSelector : StochasticSingleObjectiveSelector, ISingleObjectiveSelector {
     private ValueParameter<BoolValue> WindowingParameter {
       get { return (ValueParameter<BoolValue>)Parameters["Windowing"]; }
Index: trunk/sources/HeuristicLab.Selection/3.3/Reducer.cs
===================================================================
--- trunk/sources/HeuristicLab.Selection/3.3/Reducer.cs	(revision 3137)
+++ trunk/sources/HeuristicLab.Selection/3.3/Reducer.cs	(revision 3138)
@@ -23,5 +23,4 @@
 using HeuristicLab.Core;
 using HeuristicLab.Operators;
-using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -33,5 +32,5 @@
   [Item("Reducer", "A base class for reduction operators.")]
   [StorableClass]
-  public abstract class Reducer : SingleSuccessorOperator, IReducer {
+  public abstract class Reducer : SingleSuccessorOperator {
     protected ScopeParameter CurrentScopeParameter {
       get { return (ScopeParameter)Parameters["CurrentScope"]; }
Index: trunk/sources/HeuristicLab.Selection/3.3/RightReducer.cs
===================================================================
--- trunk/sources/HeuristicLab.Selection/3.3/RightReducer.cs	(revision 3137)
+++ trunk/sources/HeuristicLab.Selection/3.3/RightReducer.cs	(revision 3138)
@@ -22,4 +22,5 @@
 using System.Collections.Generic;
 using HeuristicLab.Core;
+using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -31,5 +32,5 @@
   [StorableClass]
   [Creatable("Test")]
-  public sealed class RightReducer : Reducer {
+  public sealed class RightReducer : Reducer, IReducer {
     public RightReducer() : base() { }
 
Index: trunk/sources/HeuristicLab.Selection/3.3/Selector.cs
===================================================================
--- trunk/sources/HeuristicLab.Selection/3.3/Selector.cs	(revision 3137)
+++ trunk/sources/HeuristicLab.Selection/3.3/Selector.cs	(revision 3138)
@@ -22,7 +22,5 @@
 using System.Collections.Generic;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 using HeuristicLab.Operators;
-using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
Index: trunk/sources/HeuristicLab.Selection/3.3/SingleObjectiveSelector.cs
===================================================================
--- trunk/sources/HeuristicLab.Selection/3.3/SingleObjectiveSelector.cs	(revision 3137)
+++ trunk/sources/HeuristicLab.Selection/3.3/SingleObjectiveSelector.cs	(revision 3138)
@@ -22,5 +22,4 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
-using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -32,5 +31,5 @@
   [Item("SingleObjectiveSelector", "A base class for selection operators which consider a single double quality value for selection.")]
   [StorableClass]
-  public abstract class SingleObjectiveSelector : Selector, ISingleObjectiveSelector {
+  public abstract class SingleObjectiveSelector : Selector {
     protected ValueParameter<BoolValue> CopySelectedParameter {
       get { return (ValueParameter<BoolValue>)Parameters["CopySelected"]; }
Index: trunk/sources/HeuristicLab.Selection/3.3/TournamentSelector.cs
===================================================================
--- trunk/sources/HeuristicLab.Selection/3.3/TournamentSelector.cs	(revision 3137)
+++ trunk/sources/HeuristicLab.Selection/3.3/TournamentSelector.cs	(revision 3138)
@@ -24,4 +24,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -34,5 +35,5 @@
   [StorableClass]
   [Creatable("Test")]
-  public sealed class TournamentSelector : StochasticSingleObjectiveSelector {
+  public sealed class TournamentSelector : StochasticSingleObjectiveSelector, ISingleObjectiveSelector {
     public ValueLookupParameter<IntValue> GroupSizeParameter {
       get { return (ValueLookupParameter<IntValue>)Parameters["GroupSize"]; }
Index: trunk/sources/HeuristicLab.Selection/3.3/WorstSelector.cs
===================================================================
--- trunk/sources/HeuristicLab.Selection/3.3/WorstSelector.cs	(revision 3137)
+++ trunk/sources/HeuristicLab.Selection/3.3/WorstSelector.cs	(revision 3138)
@@ -20,9 +20,10 @@
 #endregion
 
+using System.Collections.Generic;
 using System.Linq;
-using System.Collections.Generic;
 using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Data;
 
 namespace HeuristicLab.Selection {
@@ -33,5 +34,5 @@
   [StorableClass]
   [Creatable("Test")]
-  public sealed class WorstSelector : SingleObjectiveSelector {
+  public sealed class WorstSelector : SingleObjectiveSelector, ISingleObjectiveSelector {
     public WorstSelector() : base() { }
 