Index: trunk/sources/HeuristicLab 3.3.sln
===================================================================
--- trunk/sources/HeuristicLab 3.3.sln	(revision 3150)
+++ trunk/sources/HeuristicLab 3.3.sln	(revision 3158)
@@ -47,4 +47,5 @@
 		{F62BCD22-FB83-4444-9401-8031C2487A86} = {F62BCD22-FB83-4444-9401-8031C2487A86}
 		{E0B45023-CB84-48A1-A1B7-8295B64B7BAD} = {E0B45023-CB84-48A1-A1B7-8295B64B7BAD}
+		{CDA28124-ACD0-4231-8EB0-C510B361F84E} = {CDA28124-ACD0-4231-8EB0-C510B361F84E}
 		{14AB8D24-25BC-400C-A846-4627AA945192} = {14AB8D24-25BC-400C-A846-4627AA945192}
 		{C36BD924-A541-4A00-AFA8-41701378DDC5} = {C36BD924-A541-4A00-AFA8-41701378DDC5}
@@ -74,6 +75,6 @@
 		{81609E8A-9757-4865-8B89-0B6603F769E8} = {81609E8A-9757-4865-8B89-0B6603F769E8}
 		{8FA6898D-E4B0-4E08-A6D6-F9F520E7959F} = {8FA6898D-E4B0-4E08-A6D6-F9F520E7959F}
+		{D767C38D-8014-46B0-9A32-03A3AECCE34A} = {D767C38D-8014-46B0-9A32-03A3AECCE34A}
 		{BF7D9494-A586-457B-8DF9-ED599F9E6A71} = {BF7D9494-A586-457B-8DF9-ED599F9E6A71}
-		{600287A3-8714-453E-B875-A05F3EB72315} = {600287A3-8714-453E-B875-A05F3EB72315}
 		{DBECB8B0-B166-4133-BAF1-ED67C3FD7FCA} = {DBECB8B0-B166-4133-BAF1-ED67C3FD7FCA}
 		{887425B4-4348-49ED-A457-B7D2C26DDBF9} = {887425B4-4348-49ED-A457-B7D2C26DDBF9}
@@ -83,5 +84,4 @@
 		{66D249C3-A01D-42A8-82A2-919BC8EC3D83} = {66D249C3-A01D-42A8-82A2-919BC8EC3D83}
 		{4C3305C4-E440-4EAD-B218-68D77AE51543} = {4C3305C4-E440-4EAD-B218-68D77AE51543}
-		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C} = {DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}
 		{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B} = {102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}
 		{13CA37D6-4111-4E7B-BE2E-AF3DE462D384} = {13CA37D6-4111-4E7B-BE2E-AF3DE462D384}
@@ -162,8 +162,4 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Optimization.Views-3.3", "HeuristicLab.Optimization.Views\3.3\HeuristicLab.Optimization.Views-3.3.csproj", "{662B4B15-8F4D-4AE5-B3EB-D91C215F5AF2}"
 EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.TSP-3.3", "HeuristicLab.Problems.TSP\3.3\HeuristicLab.Problems.TSP-3.3.csproj", "{600287A3-8714-453E-B875-A05F3EB72315}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.TSP.Views-3.3", "HeuristicLab.Problems.TSP.Views\3.3\HeuristicLab.Problems.TSP.Views-3.3.csproj", "{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}"
-EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Algorithms.SGA-3.3", "HeuristicLab.Algorithms.SGA\3.3\HeuristicLab.Algorithms.SGA-3.3.csproj", "{4C3305C4-E440-4EAD-B218-68D77AE51543}"
 EndProject
@@ -221,4 +217,8 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.TestFunctions.SingleObjective.Views-3.3", "HeuristicLab.Problems.TestFunctions.SingleObjective.Views\3.3\HeuristicLab.Problems.TestFunctions.SingleObjective.Views-3.3.csproj", "{6AE0E1F5-D3FF-43A3-90E1-2435E7493FB5}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.TravelingSalesman-3.3", "HeuristicLab.Problems.TravelingSalesman\3.3\HeuristicLab.Problems.TravelingSalesman-3.3.csproj", "{D767C38D-8014-46B0-9A32-03A3AECCE34A}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.TravelingSalesman.Views-3.3", "HeuristicLab.Problems.TravelingSalesman.Views\3.3\HeuristicLab.Problems.TravelingSalesman.Views-3.3.csproj", "{CDA28124-ACD0-4231-8EB0-C510B361F84E}"
 EndProject
 Global
@@ -820,36 +820,4 @@
 		{662B4B15-8F4D-4AE5-B3EB-D91C215F5AF2}.Services|x64.ActiveCfg = Release|x64
 		{662B4B15-8F4D-4AE5-B3EB-D91C215F5AF2}.Services|x86.ActiveCfg = Release|x86
-		{600287A3-8714-453E-B875-A05F3EB72315}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{600287A3-8714-453E-B875-A05F3EB72315}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{600287A3-8714-453E-B875-A05F3EB72315}.Debug|x64.ActiveCfg = Debug|x64
-		{600287A3-8714-453E-B875-A05F3EB72315}.Debug|x64.Build.0 = Debug|x64
-		{600287A3-8714-453E-B875-A05F3EB72315}.Debug|x86.ActiveCfg = Debug|x86
-		{600287A3-8714-453E-B875-A05F3EB72315}.Debug|x86.Build.0 = Debug|x86
-		{600287A3-8714-453E-B875-A05F3EB72315}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{600287A3-8714-453E-B875-A05F3EB72315}.Release|Any CPU.Build.0 = Release|Any CPU
-		{600287A3-8714-453E-B875-A05F3EB72315}.Release|x64.ActiveCfg = Release|x64
-		{600287A3-8714-453E-B875-A05F3EB72315}.Release|x64.Build.0 = Release|x64
-		{600287A3-8714-453E-B875-A05F3EB72315}.Release|x86.ActiveCfg = Release|x86
-		{600287A3-8714-453E-B875-A05F3EB72315}.Release|x86.Build.0 = Release|x86
-		{600287A3-8714-453E-B875-A05F3EB72315}.Services|Any CPU.ActiveCfg = Release|Any CPU
-		{600287A3-8714-453E-B875-A05F3EB72315}.Services|Any CPU.Build.0 = Release|Any CPU
-		{600287A3-8714-453E-B875-A05F3EB72315}.Services|x64.ActiveCfg = Release|x64
-		{600287A3-8714-453E-B875-A05F3EB72315}.Services|x86.ActiveCfg = Release|x86
-		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Debug|x64.ActiveCfg = Debug|x64
-		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Debug|x64.Build.0 = Debug|x64
-		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Debug|x86.ActiveCfg = Debug|x86
-		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Debug|x86.Build.0 = Debug|x86
-		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Release|Any CPU.Build.0 = Release|Any CPU
-		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Release|x64.ActiveCfg = Release|x64
-		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Release|x64.Build.0 = Release|x64
-		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Release|x86.ActiveCfg = Release|x86
-		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Release|x86.Build.0 = Release|x86
-		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Services|Any CPU.ActiveCfg = Release|Any CPU
-		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Services|Any CPU.Build.0 = Release|Any CPU
-		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Services|x64.ActiveCfg = Release|x64
-		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Services|x86.ActiveCfg = Release|x86
 		{4C3305C4-E440-4EAD-B218-68D77AE51543}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{4C3305C4-E440-4EAD-B218-68D77AE51543}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -1188,9 +1156,9 @@
 		{C458C60D-33CE-42B8-8B7A-651B698A3C96}.Services|x86.ActiveCfg = Release|x86
 		{30D8C5F1-CD3A-4EC1-907F-430177A03FBE}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{30D8C5F1-CD3A-4EC1-907F-430177A03FBE}.Debug|x64.ActiveCfg = Debug|Any CPU
-		{30D8C5F1-CD3A-4EC1-907F-430177A03FBE}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{30D8C5F1-CD3A-4EC1-907F-430177A03FBE}.Debug|x64.ActiveCfg = Debug|x64
+		{30D8C5F1-CD3A-4EC1-907F-430177A03FBE}.Debug|x86.ActiveCfg = Debug|x86
 		{30D8C5F1-CD3A-4EC1-907F-430177A03FBE}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{30D8C5F1-CD3A-4EC1-907F-430177A03FBE}.Release|x64.ActiveCfg = Release|Any CPU
-		{30D8C5F1-CD3A-4EC1-907F-430177A03FBE}.Release|x86.ActiveCfg = Release|Any CPU
+		{30D8C5F1-CD3A-4EC1-907F-430177A03FBE}.Release|x64.ActiveCfg = Release|x64
+		{30D8C5F1-CD3A-4EC1-907F-430177A03FBE}.Release|x86.ActiveCfg = Release|x86
 		{30D8C5F1-CD3A-4EC1-907F-430177A03FBE}.Services|Any CPU.ActiveCfg = Release|Any CPU
 		{30D8C5F1-CD3A-4EC1-907F-430177A03FBE}.Services|Any CPU.Build.0 = Release|Any CPU
@@ -1200,9 +1168,9 @@
 		{30D8C5F1-CD3A-4EC1-907F-430177A03FBE}.Services|x86.Build.0 = Release|x86
 		{EBEBA863-DD05-4331-BE25-5758B15F7407}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{EBEBA863-DD05-4331-BE25-5758B15F7407}.Debug|x64.ActiveCfg = Debug|Any CPU
-		{EBEBA863-DD05-4331-BE25-5758B15F7407}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{EBEBA863-DD05-4331-BE25-5758B15F7407}.Debug|x64.ActiveCfg = Debug|x64
+		{EBEBA863-DD05-4331-BE25-5758B15F7407}.Debug|x86.ActiveCfg = Debug|x86
 		{EBEBA863-DD05-4331-BE25-5758B15F7407}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{EBEBA863-DD05-4331-BE25-5758B15F7407}.Release|x64.ActiveCfg = Release|Any CPU
-		{EBEBA863-DD05-4331-BE25-5758B15F7407}.Release|x86.ActiveCfg = Release|Any CPU
+		{EBEBA863-DD05-4331-BE25-5758B15F7407}.Release|x64.ActiveCfg = Release|x64
+		{EBEBA863-DD05-4331-BE25-5758B15F7407}.Release|x86.ActiveCfg = Release|x86
 		{EBEBA863-DD05-4331-BE25-5758B15F7407}.Services|Any CPU.ActiveCfg = Release|Any CPU
 		{EBEBA863-DD05-4331-BE25-5758B15F7407}.Services|Any CPU.Build.0 = Release|Any CPU
@@ -1251,6 +1219,8 @@
 		{E0B45023-CB84-48A1-A1B7-8295B64B7BAD}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{E0B45023-CB84-48A1-A1B7-8295B64B7BAD}.Release|Any CPU.Build.0 = Release|Any CPU
-		{E0B45023-CB84-48A1-A1B7-8295B64B7BAD}.Release|x64.ActiveCfg = Release|Any CPU
-		{E0B45023-CB84-48A1-A1B7-8295B64B7BAD}.Release|x86.ActiveCfg = Release|Any CPU
+		{E0B45023-CB84-48A1-A1B7-8295B64B7BAD}.Release|x64.ActiveCfg = Release|x64
+		{E0B45023-CB84-48A1-A1B7-8295B64B7BAD}.Release|x64.Build.0 = Release|x64
+		{E0B45023-CB84-48A1-A1B7-8295B64B7BAD}.Release|x86.ActiveCfg = Release|x86
+		{E0B45023-CB84-48A1-A1B7-8295B64B7BAD}.Release|x86.Build.0 = Release|x86
 		{E0B45023-CB84-48A1-A1B7-8295B64B7BAD}.Services|Any CPU.ActiveCfg = Release|Any CPU
 		{E0B45023-CB84-48A1-A1B7-8295B64B7BAD}.Services|Any CPU.Build.0 = Release|Any CPU
@@ -1259,10 +1229,14 @@
 		{88B9B0E3-344E-4196-82A3-0F9732506FE8}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{88B9B0E3-344E-4196-82A3-0F9732506FE8}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{88B9B0E3-344E-4196-82A3-0F9732506FE8}.Debug|x64.ActiveCfg = Debug|Any CPU
-		{88B9B0E3-344E-4196-82A3-0F9732506FE8}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{88B9B0E3-344E-4196-82A3-0F9732506FE8}.Debug|x64.ActiveCfg = Debug|x64
+		{88B9B0E3-344E-4196-82A3-0F9732506FE8}.Debug|x64.Build.0 = Debug|x64
+		{88B9B0E3-344E-4196-82A3-0F9732506FE8}.Debug|x86.ActiveCfg = Debug|x86
+		{88B9B0E3-344E-4196-82A3-0F9732506FE8}.Debug|x86.Build.0 = Debug|x86
 		{88B9B0E3-344E-4196-82A3-0F9732506FE8}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{88B9B0E3-344E-4196-82A3-0F9732506FE8}.Release|Any CPU.Build.0 = Release|Any CPU
-		{88B9B0E3-344E-4196-82A3-0F9732506FE8}.Release|x64.ActiveCfg = Release|Any CPU
-		{88B9B0E3-344E-4196-82A3-0F9732506FE8}.Release|x86.ActiveCfg = Release|Any CPU
+		{88B9B0E3-344E-4196-82A3-0F9732506FE8}.Release|x64.ActiveCfg = Release|x64
+		{88B9B0E3-344E-4196-82A3-0F9732506FE8}.Release|x64.Build.0 = Release|x64
+		{88B9B0E3-344E-4196-82A3-0F9732506FE8}.Release|x86.ActiveCfg = Release|x86
+		{88B9B0E3-344E-4196-82A3-0F9732506FE8}.Release|x86.Build.0 = Release|x86
 		{88B9B0E3-344E-4196-82A3-0F9732506FE8}.Services|Any CPU.ActiveCfg = Release|Any CPU
 		{88B9B0E3-344E-4196-82A3-0F9732506FE8}.Services|Any CPU.Build.0 = Release|Any CPU
@@ -1271,14 +1245,50 @@
 		{6AE0E1F5-D3FF-43A3-90E1-2435E7493FB5}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{6AE0E1F5-D3FF-43A3-90E1-2435E7493FB5}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{6AE0E1F5-D3FF-43A3-90E1-2435E7493FB5}.Debug|x64.ActiveCfg = Debug|Any CPU
-		{6AE0E1F5-D3FF-43A3-90E1-2435E7493FB5}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{6AE0E1F5-D3FF-43A3-90E1-2435E7493FB5}.Debug|x64.ActiveCfg = Debug|x64
+		{6AE0E1F5-D3FF-43A3-90E1-2435E7493FB5}.Debug|x64.Build.0 = Debug|x64
+		{6AE0E1F5-D3FF-43A3-90E1-2435E7493FB5}.Debug|x86.ActiveCfg = Debug|x86
+		{6AE0E1F5-D3FF-43A3-90E1-2435E7493FB5}.Debug|x86.Build.0 = Debug|x86
 		{6AE0E1F5-D3FF-43A3-90E1-2435E7493FB5}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{6AE0E1F5-D3FF-43A3-90E1-2435E7493FB5}.Release|Any CPU.Build.0 = Release|Any CPU
-		{6AE0E1F5-D3FF-43A3-90E1-2435E7493FB5}.Release|x64.ActiveCfg = Release|Any CPU
-		{6AE0E1F5-D3FF-43A3-90E1-2435E7493FB5}.Release|x86.ActiveCfg = Release|Any CPU
+		{6AE0E1F5-D3FF-43A3-90E1-2435E7493FB5}.Release|x64.ActiveCfg = Release|x64
+		{6AE0E1F5-D3FF-43A3-90E1-2435E7493FB5}.Release|x64.Build.0 = Release|x64
+		{6AE0E1F5-D3FF-43A3-90E1-2435E7493FB5}.Release|x86.ActiveCfg = Release|x86
+		{6AE0E1F5-D3FF-43A3-90E1-2435E7493FB5}.Release|x86.Build.0 = Release|x86
 		{6AE0E1F5-D3FF-43A3-90E1-2435E7493FB5}.Services|Any CPU.ActiveCfg = Release|Any CPU
 		{6AE0E1F5-D3FF-43A3-90E1-2435E7493FB5}.Services|Any CPU.Build.0 = Release|Any CPU
 		{6AE0E1F5-D3FF-43A3-90E1-2435E7493FB5}.Services|x64.ActiveCfg = Release|Any CPU
 		{6AE0E1F5-D3FF-43A3-90E1-2435E7493FB5}.Services|x86.ActiveCfg = Release|Any CPU
+		{D767C38D-8014-46B0-9A32-03A3AECCE34A}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{D767C38D-8014-46B0-9A32-03A3AECCE34A}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{D767C38D-8014-46B0-9A32-03A3AECCE34A}.Debug|x64.ActiveCfg = Debug|x64
+		{D767C38D-8014-46B0-9A32-03A3AECCE34A}.Debug|x64.Build.0 = Debug|x64
+		{D767C38D-8014-46B0-9A32-03A3AECCE34A}.Debug|x86.ActiveCfg = Debug|x86
+		{D767C38D-8014-46B0-9A32-03A3AECCE34A}.Debug|x86.Build.0 = Debug|x86
+		{D767C38D-8014-46B0-9A32-03A3AECCE34A}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{D767C38D-8014-46B0-9A32-03A3AECCE34A}.Release|Any CPU.Build.0 = Release|Any CPU
+		{D767C38D-8014-46B0-9A32-03A3AECCE34A}.Release|x64.ActiveCfg = Release|x64
+		{D767C38D-8014-46B0-9A32-03A3AECCE34A}.Release|x64.Build.0 = Release|x64
+		{D767C38D-8014-46B0-9A32-03A3AECCE34A}.Release|x86.ActiveCfg = Release|x86
+		{D767C38D-8014-46B0-9A32-03A3AECCE34A}.Release|x86.Build.0 = Release|x86
+		{D767C38D-8014-46B0-9A32-03A3AECCE34A}.Services|Any CPU.ActiveCfg = Release|x64
+		{D767C38D-8014-46B0-9A32-03A3AECCE34A}.Services|x64.ActiveCfg = Release|x64
+		{D767C38D-8014-46B0-9A32-03A3AECCE34A}.Services|x64.Build.0 = Release|x64
+		{D767C38D-8014-46B0-9A32-03A3AECCE34A}.Services|x86.ActiveCfg = Release|x64
+		{CDA28124-ACD0-4231-8EB0-C510B361F84E}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{CDA28124-ACD0-4231-8EB0-C510B361F84E}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{CDA28124-ACD0-4231-8EB0-C510B361F84E}.Debug|x64.ActiveCfg = Debug|x64
+		{CDA28124-ACD0-4231-8EB0-C510B361F84E}.Debug|x64.Build.0 = Debug|x64
+		{CDA28124-ACD0-4231-8EB0-C510B361F84E}.Debug|x86.ActiveCfg = Debug|x86
+		{CDA28124-ACD0-4231-8EB0-C510B361F84E}.Debug|x86.Build.0 = Debug|x86
+		{CDA28124-ACD0-4231-8EB0-C510B361F84E}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{CDA28124-ACD0-4231-8EB0-C510B361F84E}.Release|Any CPU.Build.0 = Release|Any CPU
+		{CDA28124-ACD0-4231-8EB0-C510B361F84E}.Release|x64.ActiveCfg = Release|x64
+		{CDA28124-ACD0-4231-8EB0-C510B361F84E}.Release|x64.Build.0 = Release|x64
+		{CDA28124-ACD0-4231-8EB0-C510B361F84E}.Release|x86.ActiveCfg = Release|x86
+		{CDA28124-ACD0-4231-8EB0-C510B361F84E}.Release|x86.Build.0 = Release|x86
+		{CDA28124-ACD0-4231-8EB0-C510B361F84E}.Services|Any CPU.ActiveCfg = Release|x64
+		{CDA28124-ACD0-4231-8EB0-C510B361F84E}.Services|x64.ActiveCfg = Release|x64
+		{CDA28124-ACD0-4231-8EB0-C510B361F84E}.Services|x64.Build.0 = Release|x64
+		{CDA28124-ACD0-4231-8EB0-C510B361F84E}.Services|x86.ActiveCfg = Release|x64
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution