Index: trunk/sources/HeuristicLab 3.3/MergeConfigs.cmd
===================================================================
--- trunk/sources/HeuristicLab 3.3/MergeConfigs.cmd	(revision 3162)
+++ trunk/sources/HeuristicLab 3.3/MergeConfigs.cmd	(revision 3163)
@@ -1,3 +1,4 @@
 ConfigMerger "%SolutionDir%\HeuristicLab.PluginInfrastructure\%Outdir%\HeuristicLab.PluginInfrastructure.dll.config" "HeuristicLab.exe.config"
+ConfigMerger "%SolutionDir%\HeuristicLab.Optimizer\3.3\%Outdir%\HeuristicLab.Optimizer-3.3.dll.config" "HeuristicLab.exe.config"
 ConfigMerger "%SolutionDir%\HeuristicLab.Persistence\3.3\%Outdir%\HeuristicLab.Persistence-3.3.dll.config" "HeuristicLab.exe.config"
 ConfigMerger "%SolutionDir%\HeuristicLab.Tracing\3.2\%Outdir%\HeuristicLab.Tracing-3.2.dll.config" "HeuristicLab.exe.config"
Index: trunk/sources/HeuristicLab.Core.Views/3.3/OperatorsSidebar.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Core.Views/3.3/OperatorsSidebar.Designer.cs	(revision 3162)
+++ trunk/sources/HeuristicLab.Core.Views/3.3/OperatorsSidebar.Designer.cs	(revision 3163)
@@ -65,5 +65,4 @@
       this.Name = "OperatorsSidebar";
       this.Size = new System.Drawing.Size(316, 296);
-      this.Load += new System.EventHandler(this.OperatorsSidebar_Load);
       this.ResumeLayout(false);
 
Index: trunk/sources/HeuristicLab.Core.Views/3.3/OperatorsSidebar.cs
===================================================================
--- trunk/sources/HeuristicLab.Core.Views/3.3/OperatorsSidebar.cs	(revision 3162)
+++ trunk/sources/HeuristicLab.Core.Views/3.3/OperatorsSidebar.cs	(revision 3163)
@@ -31,8 +31,8 @@
     }
 
-    protected virtual void OperatorsSidebar_Load(object sender, EventArgs e) {
+    protected override void OnInitialized(EventArgs e) {
+      base.OnInitialized(e);
       typeSelector.Configure(typeof(IOperator), false, false);
     }
-
     protected override void OnClosing(FormClosingEventArgs e) {
       base.OnClosing(e);
Index: trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj	(revision 3162)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj	(revision 3163)
@@ -87,4 +87,16 @@
     <None Include="HeuristicLabOptimizerPlugin.cs.frame" />
     <Compile Include="FileManager.cs" />
+    <Compile Include="MenuItems\StartPageMenuItem.cs" />
+    <Compile Include="Properties\Settings.Designer.cs">
+      <AutoGen>True</AutoGen>
+      <DesignTimeSharedInput>True</DesignTimeSharedInput>
+      <DependentUpon>Settings.settings</DependentUpon>
+    </Compile>
+    <Compile Include="StartPage.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="StartPage.Designer.cs">
+      <DependentUpon>StartPage.cs</DependentUpon>
+    </Compile>
     <Compile Include="MenuItems\CloseMenuItem.cs" />
     <Compile Include="MenuItems\CloseAllMenuItem.cs" />
@@ -123,6 +135,11 @@
   </ItemGroup>
   <ItemGroup>
+    <None Include="app.config" />
     <None Include="HeuristicLab.snk" />
     <None Include="Properties\AssemblyInfo.frame" />
+    <None Include="Properties\Settings.settings">
+      <Generator>SettingsSingleFileGenerator</Generator>
+      <LastGenOutput>Settings.Designer.cs</LastGenOutput>
+    </None>
   </ItemGroup>
   <ItemGroup>
Index: trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/OperatorsMenuItem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/OperatorsMenuItem.cs	(revision 3162)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/OperatorsMenuItem.cs	(revision 3163)
@@ -38,5 +38,5 @@
     }
     public override int Position {
-      get { return 2100; }
+      get { return 2200; }
     }
 
@@ -46,6 +46,8 @@
 
       menuItem = ToolStripItem as ToolStripMenuItem;
-      if (menuItem != null)
+      if (menuItem != null) {
         menuItem.CheckOnClick = true;
+        menuItem.Checked = true;
+      }
     }
 
@@ -60,7 +62,5 @@
 
     public override void Execute() {
-      var view = (from v in MainFormManager.MainForm.Views
-                 where v is OperatorsSidebar
-                 select v as OperatorsSidebar).FirstOrDefault();
+      var view = MainFormManager.MainForm.Views.OfType<OperatorsSidebar>().FirstOrDefault();
       if (view.IsShown)
         view.Hide();
Index: trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/StartPageMenuItem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/StartPageMenuItem.cs	(revision 3163)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/StartPageMenuItem.cs	(revision 3163)
@@ -0,0 +1,73 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Windows.Forms;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Optimizer.MenuItems {
+  internal class StartPageMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItem, IOptimizerUserInterfaceItemProvider {
+    private ToolStripMenuItem menuItem;
+
+    public override string Name {
+      get { return "&Start Page"; }
+    }
+    public override IEnumerable<string> Structure {
+      get { return new string[] { "&View" }; }
+    }
+    public override int Position {
+      get { return 2100; }
+    }
+
+    protected override void OnToolStripItemSet(EventArgs e) {
+      MainFormManager.MainForm.ViewShown += new EventHandler<ViewShownEventArgs>(MainForm_ViewShown);
+      MainFormManager.MainForm.ViewClosed += new EventHandler<ViewEventArgs>(MainForm_ViewClosed);
+
+      menuItem = ToolStripItem as ToolStripMenuItem;
+      if (menuItem != null) {
+        menuItem.CheckOnClick = true;
+        menuItem.Checked = Properties.Settings.Default.ShowStartPage;
+      }
+    }
+
+    private void MainForm_ViewShown(object sender, ViewShownEventArgs e) {
+      if ((e.View is StartPage) && (menuItem != null))
+        menuItem.Checked = true;
+    }
+    private void MainForm_ViewClosed(object sender, ViewEventArgs e) {
+      if ((e.View is StartPage) && (menuItem != null))
+        menuItem.Checked = false;
+    }
+
+    public override void Execute() {
+      var view = MainFormManager.MainForm.Views.OfType<StartPage>().FirstOrDefault();
+      if (view == null) {
+        view = new StartPage();
+        view.Show();
+      } else {
+        view.Close();
+      }
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Optimizer/3.3/OptimizerMainForm.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/OptimizerMainForm.cs	(revision 3162)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/OptimizerMainForm.cs	(revision 3163)
@@ -50,4 +50,8 @@
       operatorsSidebar.Dock = DockStyle.Left;
       operatorsSidebar.Show();
+      if (Properties.Settings.Default.ShowStartPage) {
+        StartPage startPage = new StartPage();
+        startPage.Show();
+      }
     }
   }
Index: trunk/sources/HeuristicLab.Optimizer/3.3/Properties/Settings.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/Properties/Settings.Designer.cs	(revision 3163)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/Properties/Settings.Designer.cs	(revision 3163)
@@ -0,0 +1,38 @@
+﻿//------------------------------------------------------------------------------
+// <auto-generated>
+//     This code was generated by a tool.
+//     Runtime Version:2.0.50727.4927
+//
+//     Changes to this file may cause incorrect behavior and will be lost if
+//     the code is regenerated.
+// </auto-generated>
+//------------------------------------------------------------------------------
+
+namespace HeuristicLab.Optimizer.Properties {
+    
+    
+    [global::System.Runtime.CompilerServices.CompilerGeneratedAttribute()]
+    [global::System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.VisualStudio.Editors.SettingsDesigner.SettingsSingleFileGenerator", "9.0.0.0")]
+    internal sealed partial class Settings : global::System.Configuration.ApplicationSettingsBase {
+        
+        private static Settings defaultInstance = ((Settings)(global::System.Configuration.ApplicationSettingsBase.Synchronized(new Settings())));
+        
+        public static Settings Default {
+            get {
+                return defaultInstance;
+            }
+        }
+        
+        [global::System.Configuration.UserScopedSettingAttribute()]
+        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+        [global::System.Configuration.DefaultSettingValueAttribute("True")]
+        public bool ShowStartPage {
+            get {
+                return ((bool)(this["ShowStartPage"]));
+            }
+            set {
+                this["ShowStartPage"] = value;
+            }
+        }
+    }
+}
Index: trunk/sources/HeuristicLab.Optimizer/3.3/Properties/Settings.settings
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/Properties/Settings.settings	(revision 3163)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/Properties/Settings.settings	(revision 3163)
@@ -0,0 +1,9 @@
+﻿<?xml version='1.0' encoding='utf-8'?>
+<SettingsFile xmlns="http://schemas.microsoft.com/VisualStudio/2004/01/settings" CurrentProfile="(Default)" GeneratedClassNamespace="HeuristicLab.Optimizer.Properties" GeneratedClassName="Settings">
+  <Profiles />
+  <Settings>
+    <Setting Name="ShowStartPage" Type="System.Boolean" Scope="User">
+      <Value Profile="(Default)">True</Value>
+    </Setting>
+  </Settings>
+</SettingsFile>
Index: trunk/sources/HeuristicLab.Optimizer/3.3/StartPage.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/StartPage.Designer.cs	(revision 3163)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/StartPage.Designer.cs	(revision 3163)
@@ -0,0 +1,79 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Optimizer {
+  partial class StartPage {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing) {
+        if (components != null) components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.showStartPageCheckBox = new System.Windows.Forms.CheckBox();
+      this.SuspendLayout();
+      // 
+      // showStartPageCheckBox
+      // 
+      this.showStartPageCheckBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.showStartPageCheckBox.AutoSize = true;
+      this.showStartPageCheckBox.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
+      this.showStartPageCheckBox.Location = new System.Drawing.Point(3, 262);
+      this.showStartPageCheckBox.Name = "showStartPageCheckBox";
+      this.showStartPageCheckBox.Size = new System.Drawing.Size(158, 17);
+      this.showStartPageCheckBox.TabIndex = 0;
+      this.showStartPageCheckBox.Text = "Show Start Page on Startup";
+      this.showStartPageCheckBox.UseVisualStyleBackColor = true;
+      this.showStartPageCheckBox.CheckedChanged += new System.EventHandler(this.showStartPageCheckBox_CheckedChanged);
+      // 
+      // StartPage
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.showStartPageCheckBox);
+      this.Name = "StartPage";
+      this.Size = new System.Drawing.Size(508, 282);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.CheckBox showStartPageCheckBox;
+  }
+}
Index: trunk/sources/HeuristicLab.Optimizer/3.3/StartPage.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/StartPage.cs	(revision 3163)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/StartPage.cs	(revision 3163)
@@ -0,0 +1,44 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
+
+namespace HeuristicLab.Optimizer {
+  [View("Start Page")]
+  public partial class StartPage : View {
+    public StartPage() {
+      InitializeComponent();
+      Caption = "Start Page";
+    }
+
+    protected override void OnInitialized(EventArgs e) {
+      base.OnInitialized(e);
+      showStartPageCheckBox.Checked = Properties.Settings.Default.ShowStartPage;
+    }
+
+    private void showStartPageCheckBox_CheckedChanged(object sender, EventArgs e) {
+      Properties.Settings.Default.ShowStartPage = showStartPageCheckBox.Checked;
+      Properties.Settings.Default.Save();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Optimizer/3.3/app.config
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/app.config	(revision 3163)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/app.config	(revision 3163)
@@ -0,0 +1,15 @@
+﻿<?xml version="1.0" encoding="utf-8" ?>
+<configuration>
+    <configSections>
+        <sectionGroup name="userSettings" type="System.Configuration.UserSettingsGroup, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" >
+            <section name="HeuristicLab.Optimizer.Properties.Settings" type="System.Configuration.ClientSettingsSection, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" allowExeDefinition="MachineToLocalUser" requirePermission="false" />
+        </sectionGroup>
+    </configSections>
+    <userSettings>
+        <HeuristicLab.Optimizer.Properties.Settings>
+            <setting name="ShowStartPage" serializeAs="String">
+                <value>True</value>
+            </setting>
+        </HeuristicLab.Optimizer.Properties.Settings>
+    </userSettings>
+</configuration>